#LogTo("rank6.log");;

Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/basic.g");


#############################
#list of diagrams of rank 6
#############################


#############################
#list of lines of rank 6
#############################

#parametric lines

li6ag:=function(e1,e2,e3,e4,e5,e6,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
if e1=0 then
v1:=h;
a1:=h^-1;
elif e1=1 then 
v1:=-F1;
a1:=h;
fi;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
a5:=a4;
elif e5=1 then 
v5:=-F1;
a5:=a4^-1;
fi;
if e6=0 then
v6:=a5^-1;
elif e6=1 then 
v6:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6];
end;


li6qa:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for e6 in [0..1] do
for q in Gf do
Add(li6qa,li6ag(e1,e2,e3,e4,e5,e6,q));
od;
od;
od;
od;
od;
od;
od;


li6bg:=function(e2,e3,e4,e5,e6,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
v1:=h;
a1:=h^-2;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
a5:=a4;
elif e5=1 then 
v5:=-F1;
a5:=a4^-1;
fi;
if e6=0 then
v6:=a5^-1;
elif e6=1 then 
v6:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6];
end;


li6qb:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for e6 in [0..1] do
for q in Gf do
if q^2<>F1 then
Add(li6qb,li6bg(e2,e3,e4,e5,e6,q));
fi;
od;
od;
od;
od;
od;
od;

li6cg:=function(e1,e2,e3,e4,e5,e6)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
if e1=0 then
v1:=F(3);
elif e1=1 then
v1:=F(3)^2;
fi;
a1:=-v1;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
a5:=a4;
elif e5=1 then 
v5:=-F1;
a5:=a4^-1;
fi;
if e6=0 then
v6:=a5^-1;
elif e6=1 then 
v6:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6];
end;


li6qc:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for e6 in [0..1] do
Add(li6qc,li6cg(e1,e2,e3,e4,e5,e6));
od;
od;
od;
od;
od;
od;

li6dg:=function(e2,e3,e4,e5,e6,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
v1:=h^2;
a1:=h^-2;
if e2=0 then
v2:=h;
a2:=v2^-1;
elif e2=1 then 
v2:=-F1;
a2:=h;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
a5:=a4;
elif e5=1 then 
v5:=-F1;
a5:=a4^-1;
fi;
if e6=0 then
v6:=a5^-1;
elif e6=1 then 
v6:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6];
end;


li6qd:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for e6 in [0..1] do
for q in Gf do
if q^2<>F1 then
Add(li6qd,li6dg(e2,e3,e4,e5,e6,q));
fi;
od;
od;
od;
od;
od;
od;


li6q:=Zet(Concatenation(li6qa,li6qb,li6qc,li6qd));;

#finite lines
m:=-F1;;

z:=F(3);;

li617:=[z,z^2,z,z^2,z,z^2,m,z^2,z,z^2,z];;

li618a:=[z,z^2,z,z^2,z,z^2,z,z^2,z^2,z,m];;
li618b:=[z,z^2,z,z^2,z,z^2,z,z^2,m,z^2,m];;
li618c:=[z,z^2,m,z,m,z^2,m,z^2,z,z^2,z];;
li618d:=[m,z,m,z^2,z,z^2,m,z^2,z,z^2,z];;
li618e:=[z,z^2,z,z^2,m,z,z^2,z^2,z,z^2,z];;
li618f:=[m,z^2,z,z^2,z,z^2,m,z^2,z,z^2,z];;


z:=F(3)^2;;
li617p:=[z,z^2,z,z^2,z,z^2,m,z^2,z,z^2,z];;

li618ap:=[z,z^2,z,z^2,z,z^2,z,z^2,z^2,z,m];;
li618bp:=[z,z^2,z,z^2,z,z^2,z,z^2,m,z^2,m];;
li618cp:=[z,z^2,m,z,m,z^2,m,z^2,z,z^2,z];;
li618dp:=[m,z,m,z^2,z,z^2,m,z^2,z,z^2,z];;
li618ep:=[z,z^2,z,z^2,m,z,z^2,z^2,z,z^2,z];;
li618fp:=[m,z^2,z,z^2,z,z^2,m,z^2,z,z^2,z];;


z:=F(4);;
li619a:=[z,-z,z,-z,z,-z,m,m,m,-z,z];;
li619b:=[z,-z,z,-z,z,-z,z,-z,m,-z,z];;


z:=F(4)^3;;
li619ap:=[z,-z,z,-z,z,-z,m,m,m,-z,z];;
li619bp:=[z,-z,z,-z,z,-z,z,-z,m,-z,z];;

li6f:=[
li617,li618a,li618b,li618c,li618d,li618e,li618f,
li617p,li618ap,li618bp,li618cp,li618dp,li618ep,li618fp,
li619a,li619b,
li619ap,li619bp
];;

Hli6s:=Zet(Concatenation(li6q,li6f));;

Hli6p:=[];;
for d in Hli6s do
Add(Hli6p,Permuted(d,(1,11)(2,10)(3,9)(4,8)(5,7)));
od;

Hli6:=Zet(Concatenation(Hli6s,Hli6p));;

#############################
#list of d-type diagrams of rank 6
#############################

#list of generic d6s


d6g:=function(e2,e3,e4,e5,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
v1:=h;
a1:=h^-1;
v6:=h;
a5:=h^-1;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6];
end;


d6listq:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for q in Gf do
Add(d6listq,d6g(e2,e3,e4,e5,q));
od;
od;
od;
od;
od;

z:=F(3);;
d617a:=[z,z^2,-F1,z^2,z,z^2,z,z^2,z,z,-F1];;
d617b:=[z,z^2,z,z^2,z,z^2,z,z^2,z,z^2,-F1];;

d618a:=[z,z^2,-F1,z,-F1,z^2,z,z^2,z,z^2,-F1];;
d618b:=[z,z^2,z,z^2,-F1,z,-F1,z^2,z,z^2,-F1];;
d618c:=[z,z^2,z^2,z,-F1,z^2,z,z^2,z,z,-F1];;
d618d:=[z,z^2,z,z^2,z,z^2,-F1,z,-F1,z^2,-F1];;
d618e:=[z,z^2,-F1,z^2,-F1,z,-F1,z^2,z,z,-F1];;
d618f:=[z,z^2,z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
d618g:=[z,z^2,-F1,z^2,z,z^2,-F1,z,-F1,z,-F1];;
d618h:=[z,z^2,-F1,z^2,z,z^2,z,z^2,-F1,z,-F1];;

z:=F(3)^2;;
d617ap:=[z,z^2,-F1,z^2,z,z^2,z,z^2,z,z,-F1];;
d617bp:=[z,z^2,z,z^2,z,z^2,z,z^2,z,z^2,-F1];;

d618ap:=[z,z^2,-F1,z,-F1,z^2,z,z^2,z,z^2,-F1];;
d618bp:=[z,z^2,z,z^2,-F1,z,-F1,z^2,z,z^2,-F1];;
d618cp:=[z,z^2,z^2,z,-F1,z^2,z,z^2,z,z,-F1];;
d618dp:=[z,z^2,z,z^2,z,z^2,-F1,z,-F1,z^2,-F1];;
d618ep:=[z,z^2,-F1,z^2,-F1,z,-F1,z^2,z,z,-F1];;
d618fp:=[z,z^2,z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
d618gp:=[z,z^2,-F1,z^2,z,z^2,-F1,z,-F1,z,-F1];;
d618hp:=[z,z^2,-F1,z^2,z,z^2,z,z^2,-F1,z,-F1];;


d6listf:=
[
d617a,d617b,
d617ap,d617bp,
d618a,d618b,d618c,d618d,d618e,d618f,d618g,d618h,
d618ap,d618bp,d618cp,d618dp,d618ep,d618fp,d618gp,d618hp
];;

Hd6s:=Set(Concatenation(d6listf,d6listq));;

Hd6p:=[];;
for d in Hd6s do
Add(Hd6p,Permuted(d,(1,11)(2,10)));
od;

Hd6:=Zet(Concatenation(Hd6s,Hd6p));;


#####################
# triangle in the middle, rank 6
######################

z:=F(3);;
w:=F(4);;
m:=-F1;;

Hltm6:=[
[w,-w,m,w,m,-w,w,-w,w,m,m,w],
[-w,w,m,-w,m,w,-w,w,-w,m,m,-w],
[z,z^2,m,z,m,z^2,z,z^2,m,z,m,z],
[z^2,z,m,z^2,m,z,z^2,z,m,z^2,m,z^2],
[z,z^2,m,z,m,z^2,m,z,m,z,m,z],
[z^2,z,m,z^2,m,z,m,z^2,m,z^2,m,z^2],
[z,z^2,m,z,z^2,z,m,z^2,z,z,m,z],
[z^2,z,m,z^2,z,z^2,m,z,z^2,z^2,m,z^2],
[z,z^2,m,z,m,z^2,z,z^2,z,z,m,z],
[z^2,z,m,z^2,m,z,z^2,z,z^2,z^2,m,z^2]
];;


Htm6:=Hltm6;;


#####################
# tadpoles of rank 6
######################


z:=F(3);;
w:=F(4);;
m:=-F1;;

Hta6f:=[
[z^2,z,m,z^2,z,z^2,z,z^2,z,z,m,z],
[z,z^2,m,z,z^2,z,z^2,z,z^2,z^2,m,z^2],
Permuted([z^2,z,m,z^2,z,z^2,z,z^2,z,z,m,z],(1,11)(2,12)),
Permuted([z,z^2,m,z,z^2,z,z^2,z,z^2,z^2,m,z^2],(1,11)(2,12)),
[m,w,m,-w,w,-w,w,-w,w,w,m,m],
[m,-w,m,w,-w,w,-w,w,-w,-w,m,m],
Permuted([m,w,m,-w,w,-w,w,-w,w,w,m,m],(1,11)(2,12)),
Permuted([m,-w,m,w,-w,w,-w,w,-w,-w,m,m],(1,11)(2,12))
];


ta6g:=function(e2,e3,e4,e5,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6,a6;
v1:=-F1;
v6:=-F1;
a1:=h^-1;
a6:=h^-1;
a5:=h^2;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6,a6];
end;


Hta6q:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for t in Gf do
if t^2<>F1 then
Add(Hta6q,ta6g(e1,e2,e3,e4,t));
fi;
od;
od;
od;
od;
od;

Hta6s:=Zet(Concatenation(Hta6q,Hta6f));;

Hta6p:=[];;
for d in Hta6s do
Add(Hta6p,Permuted(d,(1,11)(2,12)));
od;

Hta6:=Zet(Concatenation(Hta6s,Hta6p));;


#####################
# e6
######################


He6q:=[];;
for q in Gf do
Add(He6q,[q,q^-1,q,q^-1,q,q^-1,q,q^-1,q,q^-1,q]);
od;
He6q:=Zet(He6q);;

m:=-F1;;
z:=F(3);;
d17d:=[z,z^2,m,z,m,z^2,z,z^2,z,z^2,z];;
d17f:=[m,z,m,z^2,z,z^2,z,z^2,z,z^2,z];;
d17g:=[m,z^2,z,z^2,z,z^2,z,z^2,z,z^2,z];;
d18q:=[m,z,z^2,z,m,z^2,z,z^2,z,z^2,z];;
d18t:=[m,z^2,m,z,m,z^2,z,z^2,z,z^2,z];;
d18u:=[z^2,z,m,z^2,z,z^2,z,z^2,z,z^2,z];;
z:=F(3)^2;;
d17dp:=[z,z^2,m,z,m,z^2,z,z^2,z,z^2,z];;
d17fp:=[m,z,m,z^2,z,z^2,z,z^2,z,z^2,z];;
d17gp:=[m,z^2,z,z^2,z,z^2,z,z^2,z,z^2,z];;
d18qp:=[m,z,z^2,z,m,z^2,z,z^2,z,z^2,z];;
d18tp:=[m,z^2,m,z,m,z^2,z,z^2,z,z^2,z];;
d18up:=[z^2,z,m,z^2,z,z^2,z,z^2,z,z^2,z];;
z:=F(4);;
d19e:=[z,-z,m,z,m,-z,z,-z,z,-z,z];;
d19f:=[m,z,m,-z,z,-z,z,-z,z,-z,z];;
d19g:=[m,-z,z,-z,z,-z,z,-z,z,-z,z];;
z:=-F(4);;
d19ep:=[z,-z,m,z,m,-z,z,-z,z,-z,z];;
d19fp:=[m,z,m,-z,z,-z,z,-z,z,-z,z];;
d19gp:=[m,-z,z,-z,z,-z,z,-z,z,-z,z];;

He6f:=[
d17d,d17f,d17g,
d18q,d18t,d18u,
d19e,d19f,d19g,
d17dp,d17fp,d17gp,
d18qp,d18tp,d18up,
d19ep,d19fp,d19gp
];;

He6fperm:=[];;
for d in He6f do
Add(He6fperm,Permuted(d,(1,9)(2,8)(3,7)(4,6)));
od;

He6s:=Zet(Concatenation(He6q,He6f,He6fperm));;

He6p:=[];;
for d in He6s do
Add(He6p,Permuted(d,(1,9)(2,8)(3,7)(4,6)));
od;

He6:=Zet(Concatenation(He6s,He6p));;




