#LogTo("rank5.log");;

Read("/home/agustin/Dropbox/math/in-progress/conjecture/gap/basic.g");


#############################
#list of diagrams of rank 5
#############################

#############################
#list of lines of rank 5
#############################

#parametric lines

li5ag:=function(e1,e2,e3,e4,e5,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5;
if e1=0 then
v1:=h;
a1:=h^-1;
elif e1=1 then 
v1:=-F1;
a1:=h;
fi;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5];
end;


li5qa:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for q in Gf do
Add(li5qa,li5ag(e1,e2,e3,e4,e5,q));
od;
od;
od;
od;
od;
od;


li5bg:=function(e2,e3,e4,e5,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5;
v1:=h;
a1:=h^-2;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5];
end;


li5qb:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for q in Gf do
if q^2<>F1 then
Add(li5qb,li5bg(e2,e3,e4,e5,q));
fi;
od;
od;
od;
od;
od;


li5cg:=function(e1,e2,e3,e4,e5)
local v1,a1,v2,a2,v3,a3,v4,a4,v5;
if e1=0 then
v1:=F(3);
elif e1=1 then
v1:=F(3)^2;
fi;
a1:=-v1;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5];
end;


li5qc:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
Add(li5qc,li5cg(e1,e2,e3,e4,e5));
od;
od;
od;
od;
od;


li5dg:=function(e2,e3,e4,e5,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5;
v1:=h^2;
a1:=h^-2;
if e2=0 then
v2:=h;
a2:=v2^-1;
elif e2=1 then 
v2:=-F1;
a2:=h;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
a4:=a3;
elif e4=1 then 
v4:=-F1;
a4:=a3^-1;
fi;
if e5=0 then
v5:=a4^-1;
elif e5=1 then 
v5:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5];
end;


li5qd:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for e5 in [0..1] do
for q in Gf do
if q^2<>F1 then
Add(li5qd,li5dg(e2,e3,e4,e5,q));
fi;
od;
od;
od;
od;
od;

li5q:=Zet(Concatenation(li5qa,li5qb,li5qc,li5qd));;


#finite lines
m:=-F1;;
z:=F(3);;
li511:=[z,z^2,z,z^2,-F1,z^2,z,z^2,z];;
li512a:=[z,z^2,z,z^2,z,z^2,z^2,z,-F1];;
li512b:=[z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
li512c:=[m,z,m,z^2,m,z^2,z,z^2,z];;
li512d:=[m,z^2,z,z^2,m,z^2,z,z^2,z];;
li512e:=[z,z^2,m,z,z^2,z^2,z,z^2,z];;
li513a:=[m,z^2,z,z^2,z,z^2,z^2,z,m];;
li513b:=[m,z,m,z^2,z,z^2,z^2,z,m];;
li513c:=[m,z^2,z,z^2,z,z^2,m,z^2,m];;
li513d:=[z,z^2,m,z,m,z^2,z^2,z,m];;
li513e:=[m,z,m,z^2,z,z^2,m,z^2,m];;
li513f:=[z,z^2,z,z^2,m,z,-z,z,m];;
li513g:=[z,z^2,m,z,m,z^2,m,z^2,z];;
li513h:=[z,z^2,z,z^2,m,z,z^2,z^2,m];;
li513i:=[z^2,z,m,z^2,m,z^2,z,z^2,z];;
li513j:=[m,z^2,m,z,z^2,z^2,z,z^2,z];;
li513k:=[m,z,z^2,z,z^2,z^2,z,z^2,z];;

z:=F(3)^2;;
li511p:=[z,z^2,z,z^2,-F1,z^2,z,z^2,z];;
li512ap:=[z,z^2,z,z^2,z,z^2,z^2,z,-F1];;
li512bp:=[z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
li512cp:=[m,z,m,z^2,m,z^2,z,z^2,z];;
li512dp:=[m,z^2,z,z^2,m,z^2,z,z^2,z];;
li512ep:=[z,z^2,m,z,z^2,z^2,z,z^2,z];;
li513ap:=[m,z^2,z,z^2,z,z^2,z^2,z,m];;
li513bp:=[m,z,m,z^2,z,z^2,z^2,z,m];;
li513cp:=[m,z^2,z,z^2,z,z^2,m,z^2,m];;
li513dp:=[z,z^2,m,z,m,z^2,z^2,z,m];;
li513ep:=[m,z,m,z^2,z,z^2,m,z^2,m];;
li513fp:=[z,z^2,z,z^2,m,z,-z,z,m];;
li513gp:=[z,z^2,m,z,m,z^2,m,z^2,z];;
li513hp:=[z,z^2,z,z^2,m,z,z^2,z^2,m];;
li513ip:=[z^2,z,m,z^2,m,z^2,z,z^2,z];;
li513jp:=[m,z^2,m,z,z^2,z^2,z,z^2,z];;
li513kp:=[m,z,z^2,z,z^2,z^2,z,z^2,z];;


z:=F(4);;
li514a:=[z,-z,z,-z,m,m,m,-z,z];;
li514b:=[z,-z,z,-z,z,-z,m,-z,z];;

z:=F(4)^3;;
li514ap:=[z,-z,z,-z,m,m,m,-z,z];;
li514bp:=[z,-z,z,-z,z,-z,m,-z,z];;


z:=F(5);;
li515a:=[z^2,z^3,z^2,z^3,m,z^4,z,z^3,z^2];;
li515b:=[z^2,z^3,z^2,z^3,z^2,z^3,m,z,m];;
li515c:=[z^2,z^3,z^2,z^3,z^2,z^3,z,z^4,m];;

z:=F(5)^2;;
li515ap:=[z^2,z^3,z^2,z^3,m,z^4,z,z^3,z^2];;
li515bp:=[z^2,z^3,z^2,z^3,z^2,z^3,m,z,m];;
li515cp:=[z^2,z^3,z^2,z^3,z^2,z^3,z,z^4,m];;

z:=F(5)^3;;
li515app:=[z^2,z^3,z^2,z^3,m,z^4,z,z^3,z^2];;
li515bpp:=[z^2,z^3,z^2,z^3,z^2,z^3,m,z,m];;
li515cpp:=[z^2,z^3,z^2,z^3,z^2,z^3,z,z^4,m];;

z:=F(5)^4;;
li515appp:=[z^2,z^3,z^2,z^3,m,z^4,z,z^3,z^2];;
li515bppp:=[z^2,z^3,z^2,z^3,z^2,z^3,m,z,m];;
li515cppp:=[z^2,z^3,z^2,z^3,z^2,z^3,z,z^4,m];;


li5f:=[
li511,li512a,li512b,li512c,li512d,li512e,li513a,li513b,li513c,li513d,li513e,li513f,li513g,li513h,li513i,li513j,li513k,
li511p,li512ap,li512bp,li512cp,li512dp,li512ep,li513ap,li513bp,li513cp,li513dp,li513ep,li513fp,li513gp,li513hp,li513ip,li513jp,li513kp,
li514a,li514b,li514ap,li514bp,
li515a,li515b,li515c,li515ap,li515bp,li515cp,li515app,li515bpp,li515cpp,li515appp,li515bppp,li515cppp
];;

Hli5s:=Zet(Concatenation(li5q,li5f));;
Hli5p:=[];;
for d in Hli5s do
Add(Hli5p,Permuted(d,(1,9)(2,8)(3,7)(4,6)));
od;
Hli5:=Zet(Concatenation(Hli5s,Hli5p));;

#############################
#list of d-type diagrams of rank 5
#############################

#list of d5s

d5g:=function(e2,e3,e4,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5,v6;
v1:=h;
a1:=h^-1;
v5:=h;
a4:=h^-1;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
elif e4=1 then 
v4:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5];
end;


d5listq:=[];;
for e2 in [0..1] do
for e3 in [0..1] do
for e4 in [0..1] do
for q in Gf do
Add(d5listq,d5g(e2,e3,e4,q));
od;
od;
od;
od;


d5q1:=q->[q^-1,q,q^-1,q,q^-1,q,q^-1,q,q^-1];;
d5q2:=q->[q^-1,q,q^-1,q,-F1,q^-1,q,q,q^-1];;
d5q3:=q->[q^-1,q,q^-1,q,q^-1,q,-F1,q,q^-1];;
d5q4:=q->[q^-1,q,-F1,q^-1,q,q^-1,q,q,q^-1];;
d5q5:=q->[q^-1,q,q^-1,q,-F1,q^-1,-F1,q,q^-1];;
d5q6:=q->[q^-1,q,-F1,q^-1,-F1,q,q^-1,q,q^-1];;
d5q7:=q->[q^-1,q,-F1,q^-1,q,q^-1,-F1,q,q^-1];;
d5q8:=q->[q^-1,q,-F1,q^-1,-F1,q,-F1,q,q^-1];;

d5q:=function(n,q)
if n=1 then return
d5q1(q);
elif n=2 then return
d5q2(q);
elif n=3 then return
d5q3(q);
elif n=4 then return
d5q4(q);
elif n=5 then return
d5q5(q);
elif n=6 then return
d5q6(q);
elif n=7 then return
d5q7(q);
elif n=8 then return
d5q8(q);
fi;
end;

z:=F(3);;
d511a:=[z,z^2,-F1,z^2,z,z^2,z,z,-F1];;
d511b:=[z,z^2,z,z^2,z,z^2,z,z^2,-F1];;
d512a:=[z,z^2,-F1,z,-F1,z^2,z,z^2,-F1];;
d512b:=[z,z^2,z^2,z,-F1,z^2,z,z,-F1];;
d512c:=[z,z^2,-F1,z^2,-F1,z,-F1,z,-F1];;
d512d:=[z,z^2,-F1,z^2,z,z^2,-F1,z,-F1];;
d512e:=[z,z^2,z,z^2,-F1,z,-F1,z^2,-F1];;
d512f:=[z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
d512g:=[z^2,z,-F1,z^2,z,z^2,z,z^2,z];;
d513a:=[z,z^2,-F1,z,-F1,z^2,-F1,z^2,-F1];;
d513b:=[z,z^2,-F1,z,z^2,z,-F1,z^2,-F1];;
d513c:=[z,z^2,z,z^2,-F1,z,z^2,z^2,-F1];;
d513d:=[z,z^2,z^2,z,-F1,z^2,-F1,z,-F1];;
d513e:=[z,z^2,z^2,z,z^2,z,-F1,z,-F1];;
d513f:=[z,z^2,-F1,z^2,-F1,z,z^2,z,-F1];;

z:=F(3)^2;;
d511ap:=[z,z^2,-F1,z^2,z,z^2,z,z,-F1];;
d511bp:=[z,z^2,z,z^2,z,z^2,z,z^2,-F1];;
d512ap:=[z,z^2,-F1,z,-F1,z^2,z,z^2,-F1];;
d512bp:=[z,z^2,z^2,z,-F1,z^2,z,z,-F1];;
d512cp:=[z,z^2,-F1,z^2,-F1,z,-F1,z,-F1];;
d512dp:=[z,z^2,-F1,z^2,z,z^2,-F1,z,-F1];;
d512ep:=[z,z^2,z,z^2,-F1,z,-F1,z^2,-F1];;
d512fp:=[z,z^2,z,z^2,z,z^2,-F1,z^2,-F1];;
d512gp:=[z^2,z,-F1,z^2,z,z^2,z,z^2,z];;
d513ap:=[z,z^2,-F1,z,-F1,z^2,-F1,z^2,-F1];;
d513bp:=[z,z^2,-F1,z,z^2,z,-F1,z^2,-F1];;
d513cp:=[z,z^2,z,z^2,-F1,z,z^2,z^2,-F1];;
d513dp:=[z,z^2,z^2,z,-F1,z^2,-F1,z,-F1];;
d513ep:=[z,z^2,z^2,z,z^2,z,-F1,z,-F1];;
d513fp:=[z,z^2,-F1,z^2,-F1,z,z^2,z,-F1];;


z:=F(4);;
d514a:=[-F1,z,-F1,-z,z,-z,z,-z,z];;
d514b:=[-F1,-z,z,-z,z,-z,z,-z,z];;

z:=F(4)^3;;
d514ap:=[-F1,z,-F1,-z,z,-z,z,-z,z];;
d514bp:=[-F1,-z,z,-z,z,-z,z,-z,z];;

z:=F(5);;
d515a:=[-F1,z^2,-F1,z^3,z^2,z^3,z^2,z^3,z^2];;
d515b:=[-F1,z^3,z^2,z^3,z^2,z^3,z^2,z^3,z^2];;

z:=F(5)^2;;
d515ap:=[-F1,z^2,-F1,z^3,z^2,z^3,z^2,z^3,z^2];;
d515bp:=[-F1,z^3,z^2,z^3,z^2,z^3,z^2,z^3,z^2];;

z:=F(5)^3;;
d515app:=[-F1,z^2,-F1,z^3,z^2,z^3,z^2,z^3,z^2];;
d515bpp:=[-F1,z^3,z^2,z^3,z^2,z^3,z^2,z^3,z^2];;

z:=F(5)^4;;
d515appp:=[-F1,z^2,-F1,z^3,z^2,z^3,z^2,z^3,z^2];;
d515bppp:=[-F1,z^3,z^2,z^3,z^2,z^3,z^2,z^3,z^2];;


d5listf:=
[
d511a,d511b,
d512a,d512b,d512c,d512d,d512e,d512f,d512g,
d513a,d513b,d513c,d513d,d513e,d513f,
d514a,d514b,
d515a,d515b,
d511ap,d511bp,
d512ap,d512bp,d512cp,d512dp,d512ep,d512fp,d512gp,
d513ap,d513bp,d513cp,d513dp,d513ep,d513fp,
d514ap,d514bp,
d515ap,d515bp,
d515app,d515bpp,
d515appp,d515bppp
];;

Hd5s:=Zet(Concatenation(d5listf,d5listq));;

Hd5p:=[];;
for d in Hd5s do
Add(Hd5p,Permuted(d,(1,9)(2,8)));
od;

Hd5:=Zet(Concatenation(Hd5s,Hd5p));;


#####################
# triangle in the middle, rank 5
######################

m:=-F1;;

z:=F(3);;
w:=F(4);;
x:=F(5);;

tm11:=[z,z^2,m,z,m,z^2,z,z,m,z];;
tm12a:=[m,z,z^2,z,m,z^2,z,z,m,z];;
tm12b:=[m,z^2,m,z,m,z^2,z,z,m,z];;
tm13:=[z^2,z,z^2,z,m,z^2,z,z,m,z];;
tm14:=[w,-w,m,w,m,-w,w,w,m,m];;
tm15:=[x^2,x^3,m,x^2,m,x^3,x^2,x^2,m,x];;

z:=F(3)^2;;
w:=-F(4);;
x:=F(5)^2;;

tm11p:=[z,z^2,m,z,m,z^2,z,z,m,z];;
tm12ap:=[m,z,z^2,z,m,z^2,z,z,m,z];;
tm12bp:=[m,z^2,m,z,m,z^2,z,z,m,z];;
tm13p:=[z^2,z,z^2,z,m,z^2,z,z,m,z];;
tm14p:=[w,-w,m,w,m,-w,w,w,m,m];;
tm15p:=[x^2,x^3,m,x^2,m,x^3,x^2,x^2,m,x];;

x:=F(5)^3;;

tm15pp:=[x^2,x^3,m,x^2,m,x^3,x^2,x^2,m,x];;

x:=F(5)^4;;

tm15ppp:=[x^2,x^3,m,x^2,m,x^3,x^2,x^2,m,x];;


Htm5f:=[
tm11,tm12a,tm12b,tm13,tm14,tm15,
tm11p,tm12ap,tm12bp,tm13p,tm14p,tm15p,
tm15pp,tm15ppp
];;


Htm5s:=Htm5f;;
Htm5p:=[];;
for d in Htm5s do
Add(Htm5p,Permuted(d,(1,7)(2,6)(3,5)(8,10)));
od;

Htm5:=Zet(Concatenation(Htm5s,Htm5p));;


#####################
# tadpoles of rank 5
######################
m:=-F1;;

z:=F(3);;
w:=F(4);;
x:=F(5);;

ta12:=[z^2,z,m,z^2,z,z^2,z,z,m,z];;
ta13a:=[z^2,z,m,z^2,z,z^2,m,z,m,z];;
ta13b:=[z^2,z,m,z^2,m,z,m,z,m,z];;
ta13c:=[z^2,z,z^2,z,m,z^2,z,z,m,z];;
ta14:=[m,w,m,-w,w,-w,w,w,m,m];;
ta15:=[m,x^2,m,x^3,x^2,x^3,x^2,x^4,x,x^4];;

z:=F(3)^2;;
w:=-F(4);;
x:=F(5)^2;;

ta12p:=[z^2,z,m,z^2,z,z^2,z,z,m,z];;
ta13ap:=[z^2,z,m,z^2,z,z^2,m,z,m,z];;
ta13bp:=[z^2,z,m,z^2,m,z,m,z,m,z];;
ta13cp:=[z^2,z,z^2,z,m,z^2,z,z,m,z];;
ta14p:=[m,w,m,-w,w,-w,w,w,m,m];;
ta15p:=[m,x^2,m,x^3,x^2,x^3,x^2,x^4,x,x^4];;

x:=F(5)^3;;

ta15pp:=[m,x^2,m,x^3,x^2,x^3,x^2,x^4,x,x^4];;

x:=F(5)^4;;

ta15ppp:=[m,x^2,m,x^3,x^2,x^3,x^2,x^4,x,x^4];;


Hta5f:=
[ta12,ta13a,ta13b,ta14,ta15,
ta12p,ta13ap,ta13bp,ta14p,ta15p,
ta15pp,ta15ppp
];;


ta5g:=function(e2,e3,e4,h)
local v1,a1,v2,a2,v3,a3,v4,a4,v5,a5;
v1:=-F1;
v5:=-F1;
a1:=h^-1;
a5:=h^-1;
a4:=h^2;
if e2=0 then
v2:=a1^-1;
a2:=a1;
elif e2=1 then 
v2:=-F1;
a2:=a1^-1;
fi;
if e3=0 then
v3:=a2^-1;
a3:=a2;
elif e3=1 then 
v3:=-F1;
a3:=a2^-1;
fi;
if e4=0 then
v4:=a3^-1;
elif e4=1 then 
v4:=-F1;
fi;
return
[v1,a1,v2,a2,v3,a3,v4,a4,v5,a5];
end;


Hta5q:=[];;
for e1 in [0..1] do
for e2 in [0..1] do
for e3 in [0..1] do
for t in Gf do
if t^2<>F1 then
Add(Hta5q,ta5g(e1,e2,e3,t));
fi;
od;
od;
od;
od;

Hta5s:=Zet(Concatenation(Hta5q,Hta5f));;

Hta5p:=[];;
for d in Hta5s do
Add(Hta5p,Permuted(d,(1,9)(2,10)));
od;

Hta5:=Zet(Concatenation(Hta5s,Hta5p));;




